<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title> Real Estate</title>

  <!-- Nhúng các thư viện BS4 & jQuery, awesome font -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">

  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <script src="plugins/select2/js/select2.full.min.js"></script>

  <!-- SweetAlert2 -->
  <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
  <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

  <!-- Các file css tự định nghĩa thêm -->
  <link rel="stylesheet" href="style.css">

  <link href="assets/vendor/animate.css/animate.min.css" rel="stylesheet">
  <link href="assets/vendor/bootstrap/css/bootstrap.min.css" rel="stylesheet">
  <link href="assets/vendor/bootstrap-icons/bootstrap-icons.css" rel="stylesheet">
  <link href="assets/vendor/swiper/swiper-bundle.min.css" rel="stylesheet">

<script src="file/js1.js"></script>
<link rel="stylesheet" href="file/as.css">
  <!-- file vendor-->
</head>

<body id="page-top">
  
   <!-- ======= Property Search Section ======= -->
   <div class="click-closed"></div>
   <!--/ Form Search Star /-->
   <div class="box-collapse">
     <div class="title-box-d">
       <h3 class="title-d">Search Property</h3>
       
       <!-- Button trigger modal -->
     </div>
     <span class="close-box-collapse right-boxed bi bi-x"></span>
     <div class="box-collapse-wrap form ">
       <form class="form-a">
         <div class="row">
           <div class="col-md-12 mb-2">
            <label class="text-center">Find Project</label>
            <input type="text"class="form-control" id="sreach-all" placeholder="Keyword">
           </div>
           <div class="col-md-6 mb-2">
             <div class="form-group mt-3">
               <label class="pb-2" for="Type">Province</label>
               <select class="form-control form-select form-control-a select2bs4" id="select-province">
                 <option>All Province</option>
               </select>
             </div>
           </div>
           <div class="col-md-6 mb-2">
             <div class="form-group mt-3">
               <label class="pb-2" for="city">District</label>
               <select class="form-control form-select form-control-a select2bs4"  disabled id="select-district">
                 <option>All District</option>
               </select>
             </div>
           </div>
           <div class="col-md-6 mb-2">
             <div class="form-group mt-3">
               <label class="pb-2" for="bedrooms">Bedrooms</label>
               <select class="form-control form-select form-control-a" id="bedrooms">
                <option>All</option>
                <option>1</option>
                <option>2</option>
                <option>3</option>
                <option>4</option>
                <option>5</option>
                <option>6</option>
               </select>
             </div>
           </div>
           <div class="col-md-6 mb-2">
             <div class="form-group mt-3">
               <label class="pb-2" for="price">Price</label>
               <select class="form-control form-select form-control-a" id="price">
                 <option value="0">Unlimite</option>
                 <option value="7000">7000 usd</option>
                 <option value="8000">8000 usd</option>
                 <option value="9000">9000 usd</option>
                 <option value="10000">10000 usd</option>
               </select>
             </div>
           </div>
           <div class="col-md-12">
             <button type="submit" id="btn-find-project" class="btn btn-b">Search Property</button>
           </div>
         </div>
       </form>
     </div>
   </div><!-- End Property Search Section -->

  <!-- Navigation - Menu bar-->
  <nav class="navbar navbar-expand-lg navbar-light fixed-top" id="mainNav">
    <a class="nav-link text-white font-weight-bold px-4 to-slideshow-example" href="#">HOME</a>
    <button type="button" class="btn btn-b-n navbar-toggle-box navbar-toggle-box-collapse ml-5 fifth " data-bs-toggle="collapse" data-bs-target="#navbarTogglerDemo01">
      <i class="bi bi-search"></i>
    </button>
    <div class="container">
      <input type="checkbox" id="check">
      <label for="check">
        <i class="fas fa-bars" id="menu-bar-click"></i>
        <i class="fas fa-times" id="menu-bar-cancel"></i>
      </label>
      <ul class="navbar-nav ml-auto">
        <li class="nav-item pt-1 align-self-center">
          <a class="nav-link text-white font-weight-bold px-4 to-property-content" href="#">Project</a>
        </li>
        <li class="nav-item pt-1 align-self-center">
          <a class="nav-link text-white font-weight-bold px-4 to-new-post" href="#">News</a>
        </li>
        <li class="nav-item pt-1 align-self-center"><a class="nav-link text-white font-weight-bold px-4 to-utility"
            href="#">Utilities</a></li>
        <li class="nav-item pt-1 align-self-center"><a class="nav-link text-white font-weight-bold px-4 to-contact-us"
            href="#">Contact</a>
        </li>
        <li class="nav-item pt-1 align-self-center">
          <button class="px-4 glow-on-hover" id="btn-new-post"><i
              class="fa-solid fa-arrow-up-from-bracket pr-2"></i>New Post</button>
        </li>
        <li class="nav-item dropdown pt-1 align-self-center">
          <a class="nav-link px-4" data-toggle="dropdown">
            <span class="fa-stack fa-1x pl-2">
              <i class="fas fa-circle fa-stack-2x icon-background"></i>
              <i class="fa-solid fa-user fa-stack-1x"></i>
              <p class="ml-5" style="color:white ;font-family:Times New   ;" id="ten-dang-nhap"></p>
            </span>
            <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
              <div class="text-center mt-1">
                <button class="btn btn-primary" id="btn-log-in"><i class="fa-solid fa-right-to-bracket"></i> Log
                  in</button>
                  <p id="ten-dang-nhap"></p>
              </div>
              <div class="text-center mt-1">
                <button class="btn btn-danger" id="btn-log-out"><i class="fa-solid fa-right-from-bracket"></i> Log
                  out</button>
              </div>
            </div>
          </a>
        </li>
      </ul>
    </div>
  </nav>

  
  <!-- 4. Tiện ích -->

  <header class="header">
    <div class="overlay">
        <h1 class="subtitle">Estate</h1>
        <h1 class="title">Agency</h1>  
    </div>  
    <div class="shape">
        <svg viewBox="0 0 1500 200">
            <path d="m 0,240 h 1500.4828 v -71.92164 c 0,0 -286.2763,-81.79324 -743.19024,-81.79324 C 300.37862,86.28512 0,168.07836 0,168.07836 Z"/>
        </svg>
    </div>  
    <div class="mouse-icon"><div class="wheel"></div></div>
  </header>
 
  
  <!-- 3. Property content -->
  <div class="container-fluid mb-5 paddding-navbar" id="property-content">
    <div class="container py-5">
      <div class="text-center mb-5">
        <h2 class="title-text-color">Projects</h2>
      </div>
      <div class="row" id="real-estate-project">
      </div>
      <div class="page-container">
        <div id="pagination"></div>
        <input type="number" min="1" id="curpage" value="1" hidden />
      </div>
    </div>
  </div>
  <div class="container-fluid mb-5 paddding-navbar" id="new-post">
    <div class="container py-5">
      <div class="text-center mb-5">
        <h2 class="title-text-color">News</h2>
        <div class="text-right">
          <button class="btn btn-success btn-lg px-5 py-2" id="btn-filter-your-post1"><i class="fas fa-reply-all"></i>Back</button>
          <button class="btn btn-info btn-lg px-5 py-2" id="btn-filter-your-post"><i class="fa-solid fa-filter"></i> Filter Your Post</button>
        </div>
      </div>
      <div class="row" id="current-real-estate">
      </div>

    </div>
  </div>

  <!-- 3. beryupside -->
  
    <section class="section-services section-t8"  id="utility">
      <div class="container">
        <div class="row">
          <div class="col-md-12">
            <div class="title-wrap d-flex justify-content-between">
              <div class="title-box">
                <h2 class="title-a">Our Services</h2>
              </div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-md-4">
            <div class="card-box-c foo">
              <div class="card-header-c d-flex">
                <div class="card-box-ico">
                  <span class="bi bi-cart"></span>
                </div>
                <div class="card-title-c align-self-center">
                  <h2 class="title-c">Lifestyle</h2>
                </div>
              </div>
              <div class="card-body-c">
                <p class="content-c">
                  Sed porttitor lectus nibh. Cras ultricies ligula sed magna dictum porta. Praesent sapien massa,
                  convallis a pellentesque
                  nec, egestas non nisi.
                </p>
              </div>
              <div class="card-footer-c">
                <a href="#" class="link-c link-icon">Read more
                  <span class="bi bi-chevron-right"></span>
                </a>
              </div>
            </div>
          </div>
          <div class="col-md-4">
            <div class="card-box-c foo">
              <div class="card-header-c d-flex">
                <div class="card-box-ico">
                  <span class="bi bi-calendar4-week"></span>
                </div>
                <div class="card-title-c align-self-center">
                  <h2 class="title-c">Loans</h2>
                </div>
              </div>
              <div class="card-body-c">
                <p class="content-c">
                  Nulla porttitor accumsan tincidunt. Curabitur aliquet quam id dui posuere blandit. Mauris blandit
                  aliquet elit, eget tincidunt
                  nibh pulvinar a.
                </p>
              </div>
              <div class="card-footer-c">
                <a href="#" class="link-c link-icon">Read more
                  <span class="bi bi-calendar4-week"></span>
                </a>
              </div>
            </div>
          </div>
          <div class="col-md-4">
            <div class="card-box-c foo">
              <div class="card-header-c d-flex">
                <div class="card-box-ico">
                  <span class="bi bi-card-checklist"></span>
                </div>
                <div class="card-title-c align-self-center">
                  <h2 class="title-c">Sell</h2>
                </div>
              </div>
              <div class="card-body-c">
                <p class="content-c">
                  Sed porttitor lectus nibh. Cras ultricies ligula sed magna dictum porta. Praesent sapien massa,
                  convallis a pellentesque
                  nec, egestas non nisi.
                </p>
              </div>
              <div class="card-footer-c">
                <a href="#" class="link-c link-icon">Read more
                  <span class="bi bi-chevron-right"></span>
                </a>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section><!-- End Services Section -->
<!-- Slideshow body -->
<div class="cont">
	<div class="slider"></div>
	<ul class="nav"></div>
	<div data-target='right' class="side-nav side-nav--right"></div>
	<div data-target='left' class="side-nav side-nav--left"></div>
</div>


  <!-- 5. Contact us -->
  <section id="contact-us" class="section has-img-bg pb-0 ">
          <div class="container">
              <div class="row align-items-center">
                  <div class="col-md-5 my-3">
                    <h5 class="mt-2 ml-3">Follow us:</h5>
                    <a class="mx-2 mt-2 ml-3" href="#"><i class="fab fa-twitter"></i></a>
                    <a class="mx-2 mt-2 ml-3" href="#"><i class="fab fa-facebook-f"></i></a>
                    <a class="mx-2 mt-2 ml-3" href="#"><i class="text-danger fa-brands fa-youtube"></i></a>
                    <a class="mx-2 mt-2 ml-3" href="#"><i class="fa-brands fa-snapchat"></i></i></a>
                    <a class="mx-2 mt-2 ml-3" href="#"><i class="fa-brands fa-instagram"></i></i></a>
                  </div>
                  <div class="col-md-7">
                          <h4 class="mb-4">Drop Us A Line</h4>
                          <div class="form-row">
                              <div class="form-group col-sm-4">
                                  <input id="inp-contract-name" type="text" class="form-control" name="name" placeholder="Full Name">
                              </div>
                              <div class="form-group col-sm-4">
                                  <input id="inp-contract-email" type="email" class="form-control" name="Email" placeholder="Email">
                              </div>
                              <div class="form-group col-sm-4">
                                  <input id="inp-contract-phone" type="number" class="form-control" name="phone" placeholder="Phone Number">
                              </div>
                              <div class="form-group col-12">
                                  <textarea id="inp-contract-message" name="message" id="" cols="30" rows="4" class="form-control text-white rounded-0 bg-transparent" placeholder="Message"></textarea>
                              </div>
                              <div class="form-group col-12 mb-0">
                                  <button id="btn-send-contract" class="btn rounded w-md mt-3 draw-border">Send</button>
                              </div>                          
                          </div>                          
                  </div>
              </div>
          </div>
          
      <footer >
        <div class="col-12 mt-2 text-center section has-img-bg pb-0">
          <h5 >Contact Us | Hotline: 1900 0081</h5>
        </div>
      </footer>

      </section>


</body>

<script>
(function() {
  "use strict";



  /**
   * Easy selector helper function
   */
  const select = (el, all = false) => {
    el = el.trim()
    if (all) {
      return [...document.querySelectorAll(el)]
    } else {
      return document.querySelector(el)
    }
  }

  /**
   * Easy event listener function
   */
  const on = (type, el, listener, all = false) => {
    let selectEl = select(el, all)
    if (selectEl) {
      if (all) {
        selectEl.forEach(e => e.addEventListener(type, listener))
      } else {
        selectEl.addEventListener(type, listener)
      }
    }
  }

  /**
   * Search window open/close
   */
  let body = select('body');
  on('click', '.navbar-toggle-box', function(e) {
    e.preventDefault()
    body.classList.add('box-collapse-open')
    body.classList.remove('box-collapse-closed')
  })

  on('click', '.close-box-collapse', function(e) {
    e.preventDefault()
    body.classList.remove('box-collapse-open')
    body.classList.add('box-collapse-closed')
  })
  // hieu ung
  
  // hieu ung
})()

  var slideshows = document.querySelectorAll('[data-component="slideshow"]');
  slideshows.forEach(initSlideShow);

  function initSlideShow(slideshow) {

    var slides = document.querySelectorAll(`#${slideshow.id} [role="list"] .slide`);

    var index = 0, time = 3500;
    slides[index].classList.add('active');

    setInterval(() => {
      slides[index].classList.remove('active');

      index++;
      if (index === slides.length) index = 0;

      slides[index].classList.add('active');

    }, time);
  };

  $(document).ready(function () {

    //Initialize Select2 Elements
    $('.select2bs4').select2({
      theme: 'bootstrap4'
    });

 
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const token = getCookie("token");
    var gRole = "" ;
    var gUserId;
    var gTotalPage;
    var gDataRealEstate ;
    var gDataRealEstate1  ;

    const pg = document.getElementById("pagination");
    const curPage = document.getElementById("curpage");

    if (token != "") {
      $("#btn-log-in").hide();

    } else {
      $("#btn-log-out").hide();
      $("#btn-filter-your-post").hide();
      $("#btn-filter-your-post1").hide();
    }
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    callApiGetTotalPages();
   
          //end live sreach 
    const valuePage = {
      truncate: true,
      curPage: 1,
      numLinksTwoSide: 1,
      totalPages: gTotalPage
    };

    onPageLoading(); 

    pg.onclick = (e) => {
      const ele = e.target;
      if (ele.dataset.page) {
        const pageNumber = parseInt(e.target.dataset.page, 10);

        valuePage.curPage = pageNumber;
        curPage.value = pageNumber;
        pagination(valuePage);
        callApiGetProject(pageNumber - 1);
        $('html, body').animate({
        scrollTop: $("#property-content").offset().top
      }, 1000);
      }
    };
  

    $(".to-slideshow-example").click(function () {
      $('html, body').animate({
        scrollTop: $(".overlay").offset().top
      }, 1000);
    });

    $(".to-property-content").click(function () {
      $('html, body').animate({
        scrollTop: $("#property-content").offset().top
      }, 1000);
    });

    $(".to-new-post").click(function () {
      $('html, body').animate({
        scrollTop: $("#new-post").offset().top
      }, 1000);
    });

    $(".to-contact-us").click(function () {
      $('html, body').animate({
        scrollTop: $("#contact-us").offset().top
      }, 1000);
    });

    $(".to-utility").click(function () {
      $('html, body').animate({
        scrollTop: $("#utility").offset().top
      }, 1000);
    });

     // chọn bedrooms 
   $("#bedrooms").on("change" , function(e){
        e.preventDefault();
        var vValue = $("#bedrooms :selected").text();
        //console.log(vValue);
          callApiGetRealEstateById1(vValue)
        if(vValue == "All"){
          callApiGetCurrentListRealEstate()
        }
      })

      // chọn price
   $("#price").on("change" , function(e){
        e.preventDefault();
        var vValue = $("#price :selected").val();
        console.log(vValue);
        callApiGetRealEstateById2(vValue)
        if(vValue == 0){
          callApiGetCurrentListRealEstate()
        }
      })

   //Set sự kiện cho nút login
    $("#btn-log-in").on("click", function () {
      window.location.href = "../AdminFrontEnd/index.html";
    });

    //Set sự kiện cho nút logout
    $("#btn-log-out").on("click", function () {
      redirectToLogin();
    });
    // set sự kiện tìm kiếm kính lúp
    $(".fifth").on("click", function () {
      $(".click-closed").hide();
           // tìm kiếm live sreach
           if(gRole == 2 || gRole == 3 || gRole == 4) {
           $("#sreach-all").on("keyup", function() {
            var vSreach = $("#sreach-all").val();
                 callApiSreach(vSreach);

             var value = $(this).val().toLowerCase();
       
           $("#real-estate-project").filter(function() {
           $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
         });
       });
             }else{
         alertError("you must to logged in to use function sreach")
             }
    });
    //Set sự kiện cho nút đăng tin
    $("#btn-new-post").on("click", function () {
      if (token != "") {
        window.location.href = "add-realestate.html";
      } else {
        window.location.href = "../AdminFrontEnd/index.html";
      }
    });

    // gán xự kiện lấy data cho nút sửa tin
    $("#current-real-estate").on("click", ".btn-update-post", function () {
      if (token != "") {

        onBtnUpdateRealEstateClick(this);
      } else {
        window.location.href = "../AdminFrontEnd/index.html";
      }
    });

    // gán xự kiện lấy data của project
    $("#real-estate-project").on("click", ".project-detail", function () {
      onCardProjectDetailClick(this);
    });

    // gán xự kiện lấy data của project
    $("#real-estate-project").on("click", ".project-detail1", function () {
      onCardProjectDetail1Click(this);
    });

    // gán xự kiện lấy data của realEstate
    $("#current-real-estate").on("click", ".detail-real-estate", function () {
      onDetailRealEstateClick(this);
    });

    // gán xự kiện lấy data của realEstate
    $("#current-real-estate").on("click", ".detail-real-estate1", function () {
      onDetailRealEstate1Click(this);
    });

    // gán sự kiện lọc dữ liệu bài đăng của user
    $("#btn-filter-your-post").on("click", function () {
      if(gRole == 2 || gRole == 3 || gRole == 4){
          callApiGetRealEstateByEmployeeId();
          $(".btn-update-post").removeAttr("hidden");
        }
    });

     // gán back về 
     $("#btn-filter-your-post1").on("click", function () {
      callApiGetCurrentListRealEstate();;
    });

    // gán xự kiện khi ô select thay đổi
    $("#select-province").on("change", function () {
      $("#select-district").html("");
      var bProvinceId = $(this).val();
      callApiGetDistrictByProvinceId(bProvinceId);
    });

    // gán xự kiện  nút tìm kiếm realEstate
    $("#btn-find-project").on("click", function (e) {
      e.preventDefault();
      $(".click-closed").hide();
      $("#pagination").hide();
      onBtnFindProjectClick();
      $('html, body').animate({
        scrollTop: $("#property-content").offset().top
      }, 1000);
    });

    // gán sự kiện cho nút send tư vấn 
    $("#btn-send-contract").on("click" , function(){
        var vInfo = {
          hoTen : "",
          email : "",
          phone : "" ,
          note : "" ,
          status: ""
        }
        getDataFromContact(vInfo) ;
        var vCheck = validateContact(); 

        if(vCheck == true){
          callApiPostInfomationContact(vInfo);
        }
    });
    // lấy data từ form đăng ký
      function getDataFromContact(param){
      param.hoTen =  $("#inp-contract-name").val().trim();
      param.email =  $("#inp-contract-email").val().trim();
      param.phone = $("#inp-contract-phone").val().trim();
      param.note = $("#inp-contract-message").val();
      }
      // check dữ liệu từ form đăng ký
      function validateContact(){
        if($("#inp-contract-name").val() == "" ){
          alert("please enter your contact name");
          return false ;
        }
        else if($("#inp-contract-email").val() == ""){
          alert("please enter your email");
          return false ;
        }
        else if($("#inp-contract-phone").val() == ""){
          alert("please enter your phone");
          return false ;
        }
        return true ;
      }

      // gọi api gởi thông tin đăng ký
      function callApiPostInfomationContact(paramInfo){
        $.ajax({
        url: "http://localhost:8080/advises" ,
        method: "POST",
        async: "false",
        contentType:"application/json",
        data:JSON.stringify(paramInfo),
        success: function (paramResponseObj) {
          console.log(paramResponseObj);
          alert("completed , we will contact you as soon as possible , thank you and have a nice day!");
          window.location.reload();
        },
        error: function (paramError) {
          alertError("wrong infomation or sever has problem waitting for second")
        }
      });
      }
      // api sreacch theo tên 
      function callApiSreach(paramDetail){
        $.ajax({
        url: "http://localhost:8080/projects1/" + paramDetail,
        method: "GET",
        async:false,
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          getProjectDataLoadToForm(paramResponseObj);
        },
        error: function (paramError) {
          callApiGetProject(0)
        }
      });
      }

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict";
  
      callApiGetUserIdByToken();

      callApiGetProject(0);

      callApiGetAllProvinces();

      callApiGetCurrentListRealEstate();

      pagination(valuePage);

    
    }

    function onCardProjectDetailClick(paramDetail) {
      "use strict";
      // B1: Thu thập dữ liệu
      var vValueId = $(paramDetail).children('input').val();
      //console.log(vValueId);
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      const vPROJECT_DETAILS_URL = "project-details.html"
      var vUrlSiteToOpen = vPROJECT_DETAILS_URL + "?" + "projectId=" + vValueId;
      window.location.href = vUrlSiteToOpen;
    }

    function onCardProjectDetail1Click(paramDetail) {
      "use strict";
      // B1: Thu thập dữ liệu
      var vValueId = $(paramDetail).children('input').val();
      //console.log(vValueId);
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      const vPROJECT_DETAILS_URL = "project-details.html"
      var vUrlSiteToOpen = vPROJECT_DETAILS_URL + "?" + "projectId=" + vValueId;
      window.location.href = vUrlSiteToOpen;
    }

    function onDetailRealEstateClick(paramDetail) {
      "use strict";
      // B1: Thu thập dữ liệu
      var vValue = $(paramDetail).children('input').val();
      //console.log(vValue);
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      const vPROPERTIES_DETAILS_URL = "properties-details.html"
      var vUrlSiteToOpen = vPROPERTIES_DETAILS_URL + "?" + "realEstateId=" + vValue;
      window.location.href = vUrlSiteToOpen;
    }

    function onDetailRealEstate1Click(paramDetail) {
      "use strict";
      // B1: Thu thập dữ liệu
      var vValue = $(paramDetail).children('input').val();
      //console.log(vValue);
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      const vPROPERTIES_DETAILS_URL = "properties-details.html"
      var vUrlSiteToOpen = vPROPERTIES_DETAILS_URL + "?" + "realEstateId=" + vValue;
      window.location.href = vUrlSiteToOpen;
    }

    function onBtnUpdateRealEstateClick(paramDetail) {
      "use strict";
      // B1: Thu thập dữ liệu
      var vValue = $(paramDetail).children('input').val();
      //console.log(vValue);
      // B2: Kiểm tra dữ liệu(bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      callApiGetRealEstateById(vValue);
    }

    function onBtnFindProjectClick() {
      "use strict";
      // B1: Thu thập dữ liệu
      var vProvinceSelected = $("#select-province").val();
      var vDistrictSelected = $("#select-district").val();
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: xử lý hiển thị dữ liệu
      callApiGetProjectByProvinceIdAndDistrictId(vProvinceSelected, vDistrictSelected);
      
      
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function callApiGetProject(paramPageNumber) {
      $.ajax({
        url: "http://localhost:8080/projectsList/page/" + paramPageNumber,
        method: "GET",
        async: "false",
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          getProjectDataLoadToForm(paramResponseObj);
        },
        error: function (paramError) {
          //console.log(paramError);
        }
      });
    }

    // Hàm gọi api tất cả tỉnh thành
    function callApiGetAllProvinces() {
      $.ajax({
        url: "http://localhost:8080/provinces",
        method: "GET",
        async: false,
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          loadDataToProvinceSelect(paramResponseObj);
        },
        error: function (paramError) {
          console.log(paramError);
        }
      });
    }

    // Hàm xử lý gọi api lấy dữ liệu district bằng province id
    function callApiGetDistrictByProvinceId(paramProvinceId) {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/districts/province/" + paramProvinceId,
        method: "GET",
        async: false,
        headers: {
          'Content-Type': 'application/json;charset=UTF-8',
          "Authorization": "Token " + token,
        },
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);

          loadDataToDistrictSelect(paramResponseObj);
        },
        error: function (paramError) {
          console.log(paramError);
        }
      });
    }

    // Hàm xử lý gọi api lấy dữ liệu realestate bằng provinceid và districtid
    function callApiGetProjectByProvinceIdAndDistrictId(paramProvinceId, paramDistrictId) {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/projects/" + paramProvinceId + "/" + paramDistrictId,
        method: "GET",
        async: false,
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          getProjectDataLoadToForm(paramResponseObj);
        },
        error: function (paramError) {
          console.log(paramError);
          alertError("Can't find any project.");
        }
      });
    }

   
    // Hàm xử lý gọi api lấy dữ liệu realestate bằng provinceid và districtid
    function callApiGetCurrentListRealEstate() {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/currentListRealEstates",
        method: "GET",
        async: false,
        success: function (paramResponseObj) {
          // console.log(gUserId)
          gDataRealEstate = paramResponseObj
          getRealEstateDataLoadToForm(paramResponseObj);
        },
        error: function (paramError) {
          console.log(paramError);
        }
      });
    }

    function callApiGetUserIdByToken() {
      $.ajax({
        url: "http://localhost:8080/findUserId/Token",
        type: 'GET',
        dataType: "json",
        async:false,
        contentType: "application/json; charset=utf-8",
        headers: {
          "Authorization": "Token " + token,
        },
        success: function (responseObject) {
          // console.log(responseObject);
          callApiGetEmployeeByID(responseObject);
          gUserId = responseObject;
          
        },
        error: function (pAjaxContext) {
          //redirectToLogin();
        }
      });
    };

    // Hàm gọi api lấy dữ liệu realEstate bằng id
    function callApiGetRealEstateByEmployeeId() {
      $.ajax({
        url: "http://localhost:8080/realEstates/limit/employee/" + gUserId,
        method: "GET",
        async: false,
        headers: {
          "Authorization": "Token " + token,
        },
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          getRealEstateDataLoadToForm(paramResponseObj);

        },
        error: function (paramError) {
         alertError("you don't have any post , please click new post , create your post and filter again");
        }
      });
    }

    // gọi api estae by id để lọc dữ liệu price và bed 
  function callApiGetRealEstateById1(paramDetail) {
      $.ajax({
        url: "http://localhost:8080/realEstates111/" + paramDetail ,
        type: 'GET',
        dataType: "json",
        async:false,
        success: function (responseObject) {
          console.log(responseObject);
          var vValue = $("#bedrooms :selected").text();
          for(var i = 0 ; i < responseObject.length ; i++){
            if(responseObject[i].bedroom == vValue){
              getRealEstateDataLoadToForm(responseObject);
            }
          }
        },
        error: function (pAjaxContext) {
          console.log(pAjaxContext);
        }
      });
    };

    // gọi api estae by id để lọc dữ liệu price và bed 
  function callApiGetRealEstateById2(paramDetail) {
      $.ajax({
        url: "http://localhost:8080/realEstates222/" + paramDetail ,
        type: 'GET',
        dataType: "json",
        async:false,
        success: function (responseObject) {
          console.log(responseObject);
          var vValue = $("#price :selected").val();
          for(var i = 0 ; i < responseObject.length ; i++){
            if(responseObject[i].price == vValue){
              getRealEstateDataLoadToForm(responseObject);
            }
          }
            
        },
        error: function (pAjaxContext) {
          callApiGetCurrentListRealEstate()
        }
      });
    };


  // Hàm gọi api lấy dữ liệu realEstate bằng id
    function callApiGetRealEstateById(paramRealEstateId) {
      $.ajax({
        url: "http://localhost:8080/realEstates/" + paramRealEstateId,
        type: 'GET',
        dataType: "json",
        success: function (responseObject) {
          //console.log(responseObject);
          if (gUserId == responseObject.employee.employeeID ) {
            console.log(gUserId)
            const vUPDATE_REALESTATE_URL = "update-realestate.html"
            var vUrlSiteToOpen = vUPDATE_REALESTATE_URL + "?" + "realEstateId=" + paramRealEstateId;
            window.location.href = vUrlSiteToOpen;
          } else {
            alertError("Can't edit because isn't your post");
          }
        },
        error: function (pAjaxContext) {
          console.assert(pAjaxContext);
        }
      });
    };

    // Hàm gọi api lậy tổng số trang dự án
    function callApiGetTotalPages() {
      $.ajax({
        url: "http://localhost:8080/totalPageNumberProjects",
        method: "GET",
        async: false,
        success: function (paramResponseObj) {
          //console.log(paramResponseObj);
          gTotalPage = paramResponseObj;
        },
        error: function (paramError) {
          //console.log(paramError);
        }
      });
    };

    // Load dữ liệu vào ô select trên modal create ward
    function loadDataToProvinceSelect(paramResponse) {
      "use strict";
      var vProvinceSelect = $("#select-province");
      for (let i = 0; i < paramResponse.length; i++) {
        var bOption = $("<option/>");
        bOption.prop("value", paramResponse[i].id);
        bOption.prop("text", paramResponse[i].name);
        vProvinceSelect.append(bOption);
      };
    }

    // Load dữ liệu phản hồi vào ô select
    function loadDataToDistrictSelect(paramResDistrictList) {
      "use strict";
      var vDistrictSelectElement = $("#select-district");
      if (paramResDistrictList.length > 0) {
        vDistrictSelectElement.prop("disabled", false);

        for (let i = 0; i < paramResDistrictList.length; i++) {
          var bDistrictOption = $("<option/>");
          bDistrictOption.prop("value", paramResDistrictList[i].id);
          bDistrictOption.prop("text", paramResDistrictList[i].name);
          vDistrictSelectElement.append(bDistrictOption);
        };
      } else {
        vDistrictSelectElement.prop("disabled", true);
      }
    }

    // Hàm lấy danh sách các realestate
    function getProjectDataLoadToForm(paramProjectList) {
      "use strict";
      $("#real-estate-project").html("");
      var vRealEstate = "";
      for (let bI = 0; bI < paramProjectList.length; bI++) {
        vRealEstate += `
        <div class="col-lg-4 card-group">
          <div class="card card-hover mb-4">
            <!-- Card Header-->
            <div class="card-img-top">
              <a class="project-detail" href="#">
                <input type="hidden" value="` + paramProjectList[bI].id + `">
                <img src="` + paramProjectList[bI].photo + `" class="rounded-top card-img-top">
              </a>
            </div>
            <!-- Card Body-->
            <div class="card-body">
              <div class="mt-2">
                <a class="project-detail1" href="#">
                  <input type="hidden" value="` + paramProjectList[bI].id + `">
                  <h4>` + paramProjectList[bI].name + `</h4>
                </a>
                <a class="mt-2 text-dark">Address: ` + paramProjectList[bI].address + `</a><br>
                <label class="mt-2">Tỉnh thành: ` + paramProjectList[bI]._district._province.name + `</label>
              </div>
              <ul class="mt-3 list-inline">
                <li class="list-inline-item border-dark border-right pr-3"><i class="fa-duotone fa-square-m"></i>
                  ` + paramProjectList[bI].acreage + `m2</li>
                <li class="list-inline-item border-dark border-right pr-3 pl-2"><i class="fa-solid fa-warehouse mr-2"></i>` + paramProjectList[bI].numApartment + `</li>
                <li class="list-inline-item pr-3 pl-2"><i class="fa-solid fa-building"></i> ` + paramProjectList[bI].numBlock + `</li>
              </ul>
            </div>
          </div>
        </div>`;
        $("#real-estate-project").html(vRealEstate);

      }
    }

    // Hàm lấy danh sách các realestate
    function getRealEstateDataLoadToForm(paramRealEstate) {
      "use strict";
    
      $("#current-real-estate").html("");
      var vRealEstate = "";
      for (let bI = 0; bI < paramRealEstate.length; bI++) {
        vRealEstate += `
        <div class="col-lg-4 card-group">
          <div class="card card-hover mb-4">
            <!-- Card Header-->
            <div class="card-img-top">
              <a class="detail-real-estate" href="#">
                <input type="hidden" value="` + paramRealEstate[bI].id + `">
                <img src="` + paramRealEstate[bI].photo + `" class="rounded-top card-img-top">
              </a>
            </div>
            <!-- Card Body-->
            <div class="card-body">
              <div class="mt-2">
                <a class="detail-real-estate1" href="#">
                <input type="hidden" value="` + paramRealEstate[bI].id + `">
                  <h4>` + paramRealEstate[bI].apartCode + `</h4>
                </a>
                <p class="mt-2 text-dark">Địa chỉ: ` + paramRealEstate[bI].address + `</p>
                <p class="mt-2">Tạo bởi: ` + paramRealEstate[bI].employee.firstName + " " + paramRealEstate[bI].employee.lastName + `</p>
                <p class="mt-2">Added: ` + new Date(paramRealEstate[bI].dateCreate).toLocaleString() + `</p>
              </div>
              <ul class="mt-3 list-inline">
                <li class="list-inline-item border-dark border-right pr-3"><i class="fa-regular fa-square"></i>
                  ` + paramRealEstate[bI].acreage + `m2</li>
                <li class="list-inline-item border-dark border-right pr-3 pl-2"><i class="fa-solid fa-bed"></i> ` + paramRealEstate[bI].bedroom + `</li>
                <li class="list-inline-item pr-3 pl-2"><i class="fa-solid fa-bath"></i> ` + paramRealEstate[bI].bath + `</li>
              </ul>
            </div>
            <!-- Card Footer-->
            <div class="card-footer">
              <div class="row">
                <div class="col-sm-8">
                  <h4>Giá: ` + paramRealEstate[bI].price + `USD</h4>
                </div>
                <div class="col-sm-4 text-right aha">
                  <a class="btn btn-primary btn-update-post" hidden href="#">Edit
                    <input type="hidden" value="` + paramRealEstate[bI].id + `"></a>
                </div>
              </div>
            </div>
          </div>
        </div>`;
        $("#current-real-estate").html(vRealEstate);
    }
  
  }
    function redirectToLogin() {
      // Trước khi logout cần xóa token đã lưu trong cookie
      setCookie("token", "", 1);
      window.location.href = "../AdminFrontEnd/index.html";
    }

    //Hàm get Cookie
    function getCookie(cname) {
      var name = cname + "=";
      var decodedCookie = decodeURIComponent(document.cookie);
      var ca = decodedCookie.split(';');
      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
          c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
          return c.substring(name.length, c.length);
        }
      }
      return "";
    }

    //Hàm setCookie đã giới thiệu ở bài trước
    function setCookie(cname, cvalue, exdays) {
      var d = new Date();
      d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
      var expires = "expires=" + d.toUTCString();
      document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    // Hàm alert error
    function alertError(paramTitle) {
      "use strict";
      $(function () {
        var Toast = Swal.mixin({
          toast: false,
          position: 'top',
          showConfirmButton: false,
          timer: 3500
        });
        Toast.fire({
          icon: 'error',
          title: paramTitle,
        })
      });
    }

    function pagination(paramValuePage) {
      const { totalPages, curPage, truncate, numLinksTwoSide: delta } = paramValuePage;

      const range = delta + 4; // use for handle visible number of links left side

      let render = "";
      let renderTwoSide = "";
      let dot = `<li class="pg-item"><a class="pg-link">...</a></li>`;
      let countTruncate = 0; // use for ellipsis - truncate left side or right side

      // use for truncate two side
      const numberTruncateLeft = curPage - delta;
      const numberTruncateRight = curPage + delta;

      let active = "";
      for (let pos = 1; pos <= totalPages; pos++) {
        active = pos === curPage ? "active" : "";

        // truncate
        if (totalPages >= 2 * range - 1 && truncate) {
          if (numberTruncateLeft > 3 && numberTruncateRight < totalPages - 3 + 1) {
            // truncate 2 side
            if (pos >= numberTruncateLeft && pos <= numberTruncateRight) {
              renderTwoSide += renderPage(pos, active);
            }
          } else {
            // truncate left side or right side
            if (
              (curPage < range && pos <= range) ||
              (curPage > totalPages - range && pos >= totalPages - range + 1) ||
              pos === totalPages ||
              pos === 1
            ) {
              render += renderPage(pos, active);
            } else {
              countTruncate++;
              if (countTruncate === 1) render += dot;
            }
          }
        } else {
          // not truncate
          render += renderPage(pos, active);
        }
      }

      if (renderTwoSide) {
        renderTwoSide =
          renderPage(1) + dot + renderTwoSide + dot + renderPage(totalPages);
        pg.innerHTML = renderTwoSide;
      } else {
        pg.innerHTML = render;
      }
    };

    function renderPage(index, active = "") {
      return ` <li class="pg-item ${active}" data-page="${index}">
        <a class="pg-link" href="#">${index}</a>
    </li>`;
    };

       // Hàm gọi api lấy dữ liệu employee bằng id
       function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        gRole = paramResponseObj.roles[0].id
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#ten-dang-nhap").html(paramUserData.username);
              
            }

  

  });

</script>

</html>